// Polyfills
import "./polyfills";

// Main class
export { Uppload } from "./uppload";

// Base classes
export { UpploadService } from "./service";
export { UpploadEffect } from "./effect";

// Helpers
export * from "./helpers/elements";
export * from "./helpers/interfaces";
export * from "./helpers/http";
export * from "./helpers/i18n";

// Language packs
export * from "./i18n";

// Uploaders
export * from "./uploaders/xhr";

// Services
import Camera from "./services/camera";
import Instagram from "./services/microlink/instagram";
import Facebook from "./services/microlink/facebook";
import Local from "./services/local";
import GIPHY from "./services/search/giphy";
import Pixabay from "./services/search/pixabay";
import Unsplash from "./services/search/unsplash";
import Pexels from "./services/search/pexels";
import URL from "./services/microlink/url";
import Screenshot from "./services/microlink/screenshot";
import Flickr from "./services/microlink/flickr";
import Pinterest from "./services/microlink/pinterest";
import DeviantArt from "./services/microlink/deviantart";
import NineGag from "./services/microlink/9gag";
import ArtStation from "./services/microlink/artstation";
import Twitter from "./services/microlink/twitter";
import Flipboard from "./services/microlink/flipboard";
import Fotki from "./services/microlink/fotki";
import LinkedIn from "./services/microlink/linkedin";
import Reddit from "./services/microlink/reddit";
import Tumblr from "./services/microlink/tumblr";
import WeHeartIt from "./services/microlink/weheartit";
export {
  Camera,
  Instagram,
  Facebook,
  Pixabay,
  Local,
  URL,
  Screenshot,
  GIPHY,
  Unsplash,
  Pexels,
  Pinterest,
  Flickr,
  NineGag,
  DeviantArt,
  ArtStation,
  Twitter,
  Flipboard,
  Fotki,
  LinkedIn,
  Reddit,
  Tumblr,
  WeHeartIt
};

// Effects
import Crop from "./effects/crop";
import Rotate from "./effects/rotate";
import Flip from "./effects/flip";
import Preview from "./effects/preview";
import Brightness from "./effects/filter/brightness";
import Blur from "./effects/filter/blur";
import Contrast from "./effects/filter/contrast";
import Grayscale from "./effects/filter/grayscale";
import HueRotate from "./effects/filter/hue-rotate";
import Invert from "./effects/filter/invert";
import Sepia from "./effects/filter/sepia";
import Saturate from "./effects/filter/saturate";
export {
  Brightness,
  Crop,
  Rotate,
  Flip,
  Preview,
  Blur,
  Contrast,
  Grayscale,
  HueRotate,
  Invert,
  Sepia,
  Saturate
};
